'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _s2sUtils = require('s2s-utils');

var _flowFaker = require('flow-faker');

// import blog from 'babel-log'

//  weak
exports.default = ({ types: t }) => {
  return {
    inherits: _s2sUtils.inheritsOpts,
    name: 's2s-func-param-init',
    visitor: {
      Program(programPath, state) {
        const { opts: { from } } = state;
        programPath.traverse({
          FunctionDeclaration(nodePath) {
            const paramPath = nodePath.get('params.0');
            if (!paramPath) {
              return;
            }

            if (t.isIdentifier(paramPath)) {
              const { line, column } = paramPath.get('loc.start').node;
              const flowInfoObj = (0, _flowFaker.flowFakerSync)(from, {
                row: line,
                column: column + 1
              });

              if (!flowInfoObj || typeof flowInfoObj !== 'object' || Array.isArray(flowInfoObj)) {
                return;
              }

              const params = Object.keys(flowInfoObj).map(key => {
                return t.objectProperty(t.identifier(key), t.identifier(key), false, true);
              });

              paramPath.replaceWith(t.objectPattern(params, paramPath.get('typeAnnotation').node));
            }
          }
        });
      }
    }
  };
};